<template>
  <div class="record-item" :class="themeClasses">
    <div v-if="record">
      <div class="record-header">
        <time class="record-time">{{
          $t(`preorderRecordItem.${recordType}Time`, { time })
        }}</time>
        <div class="record-status">
          <status :order="record" />
        </div>
      </div>

      <div class="restaurant-info">
        <div class="restaurant-photo" :style="photoStyle"></div>
        <div>
          <div class="restaurant-name">
            {{ record.RestaurantName }}
          </div>
          <div class="restaurant-address">
            {{ record.BuildingAddress || "" }}
          </div>
          <div class="record-number">
            {{
              $t("preorderRecordItem.number", {
                number: last6Char(record.OrderId)
              })
            }}
          </div>
        </div>
      </div>

      <!-- <div class="record-payment">
        <div class="record-discount" v-if="record.payment.skm_points">
          {{ $t("preorderRecordItem.points") }} -<price
            :price="record.payment.skm_points"
          />
        </div>
        <div class="record-value"><price :price="price" /></div>
      </div> -->

      <div class="actions">
        <button v-if="cancellable" @click="cancel" class="action cancel-action">
          {{ $t("preorderRecordItem.cancel") }}
        </button>
        <button
          v-else
          class="action contact-action"
          @click="$emit('openContactPanel')"
        >
          {{ $t("preorderRecordItem.contact") }}
        </button>

        <router-link
          class="action open-action"
          :to="{ name: 'PreorderRecord', params: { orderId: record.OrderId } }"
          >{{ $t("preorderRecordItem.view") }}</router-link
        >
      </div>
    </div>

    <div class="loading" v-else>
      <div class="record-header">
        <time class="record-time"><span class="lp"></span></time>
        <div class="record-status"><span class="lp"></span></div>
      </div>

      <div class="restaurant-info">
        <div class="restaurant-photo lp"></div>
        <div>
          <div class="restaurant-name"><span class="lp"></span></div>
          <div class="restaurant-address"><span class="lp"></span></div>
          <div class="record-number"><span class="lp"></span></div>
        </div>
      </div>

      <div class="record-payment">
        <div class="record-discount"><span class="lp"></span></div>
        <div class="record-value"><span class="lp"></span></div>
      </div>

      <div class="actions">
        <button class="action contact-action"><span class="lp"></span></button>
        <span class="action open-action"><span class="lp"></span></span>
      </div>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import Price from "../Price";
import Status from "./Status";
import { mapGetters, mapState } from "vuex";
import * as Api from "@/api";
import { STATUS_AWAIT } from "@/models/preorder";
import { last6Char } from "@/utils";

export default {
  props: {
    record: {
      type: Object
    },
    type: {
      type: String,
      default: ""
    }
  },

  components: {
    Price,
    Status
  },

  methods: {
    last6Char,
    cancel() {
      if (confirm(this.$t("preorderRecords.cancelConfirm"))) {
        Api.Order.deleteOrder(this.record.OrderId, this.account).then(res => {
          if (res.data.StatusCode === 0) {
            alert(this.$t("preorderRecords.cancelError"));
          } else {
            alert(this.$t("preorderRecords.cancelSuccess"));
            this.$router.push({
              name: "PreorderRecord",
              params: {
                orderId: this.record.OrderId
              }
            });
          }
        });
      }
    }
  },

  computed: {
    ...mapState("account", ["account"]),
    ...mapGetters("theme", ["themeClasses"]),

    recordType() {
      return this.type.toLowerCase();
    },

    price() {
      return this.record.OrderAmount;
    },

    photoStyle() {
      const record = this.record;
      return {
        "background-image": `url(${record.RestaurantLogo || ""})`,
        "background-color": record.WebBannerBackgroundColor || ""
      };
    },

    time() {
      const today = moment();
      const getTime =
        this.type === "pickUp"
          ? this.record.EsPickTime
          : this.record.EsDeliveryTime;
      const reservationTime = moment(getTime);
      const todayText =
        reservationTime.format("YYYY/MM/DD") === today.format("YYYY/MM/DD")
          ? "（今日）"
          : " ";
      return reservationTime.format(`M/D[${todayText}]HH:mm`);
    },

    cancellable() {
      return this.record.OrderCancel;
    }
  }
};
</script>

<style lang="scss" scoped>
.record-item {
  border: 1px $color-sky-grey solid;
  background: $color-white;
  border-radius: 4px;
  margin-bottom: 10px;
}

.record-header {
  position: relative;
  display: flex;
  line-height: 54px;
  border-bottom: 1px $color-sky-grey dashed;

  &::after,
  &::before {
    position: absolute;
    bottom: -8px;
    content: "";
    width: 14px;
    height: 14px;
    border-radius: 50%;
    border: 1px $color-sky-grey solid;
    background: $color-genesis-white;
  }

  &::after {
    left: -7px;
    border-left: none;
    border-top: none;
  }

  &::before {
    right: -7px;
    border-right: none;
    border-bottom: none;
  }
}

.record-status {
  text-align: right;
  font-size: 14px;
  padding-right: 15px;
  color: $color-dodger-blue;

  .lp {
    display: inline-block;
    width: 100px;
    height: 14px;
  }
}

.record-time,
.record-status {
  flex: 1 1 50%;
}

.record-time {
  white-space: nowrap;
  font-size: 14px;
  padding-left: 15px;
  font-weight: 500;

  .lp {
    display: inline-block;
    width: 100px;
    height: 14px;
  }
}

.record-status-desc {
  margin-top: -18px;
  white-space: nowrap;
  font-size: 12px;
  line-height: 32px;
}

.restaurant-info {
  display: flex;
  padding-bottom: 15px;
  margin: 15px 15px 0;
  border-bottom: 1px $color-sky-grey solid;
}

.restaurant-photo {
  flex-grow: 0;
  flex-shrink: 0;
  width: 64px;
  height: 64px;
  border-radius: 4px;
  background-position: center center;
  background-size: contain;
  background-repeat: no-repeat;
  margin-right: 15px;
}

.restaurant-name {
  font-size: 16px;
  font-weight: 500;
  line-height: 28px;

  .lp {
    display: inline-block;
    width: 120px;
    height: 16px;
  }
}

.restaurant-address {
  font-size: 12px;
  line-height: 18px;

  .lp {
    display: inline-block;
    width: 180px;
    height: 12px;
  }
}

.record-number {
  font-size: 12px;
  line-height: 18px;
  color: $color-primary-grey;

  .lp {
    display: inline-block;
    width: 80px;
    height: 12px;
  }
}

.record-payment {
  display: flex;
  line-height: 48px;
  padding: 0 15px;
  border-bottom: 1px $color-sky-grey solid;
}

.record-discount,
.record-value {
  flex: 1 1 50%;
}

.record-discount {
  font-size: 12px;
  color: $color-primary-grey;

  .lp {
    display: inline-block;
    width: 50px;
    height: 12px;
  }
}

.record-value {
  text-align: right;
  font-size: 16px;
  font-weight: 600;

  .lp {
    display: inline-block;
    width: 80px;
    height: 12px;
  }
}

.actions {
  display: flex;
  text-align: center;
  line-height: 48px;
}

.action {
  flex: 1 1 50%;
  cursor: pointer;
  font-size: 16px;
  padding: 0;
  border: none;
  background: transparent;

  &:first-child {
    content: "";
    border-right: 1px $color-sky-grey solid;
  }

  .lp {
    display: inline-block;
    width: 100px;
    height: 12px;
  }
}

.open-action {
  color: $color-skm-red;

  &::after {
    content: "";
    display: inline-block;
    width: 6px;
    height: 6px;
    border: 1px $color-skm-red solid;
    border-top: none;
    border-left: none;
    transform: rotateZ(-45deg) translateY(-2px) translateX(2px);
    margin-left: 5px;
  }
}

.loading .open-action::after {
  display: none;
}

.theme-vip-member {
  .record-header {
    &::after,
    &::before {
      background: $color-gold-100;
    }
  }
}
</style>
